/*
 * ShadowVolume.h
 *
 * Copyright (C) 2009 Matthias Schiffer <matthias@gamezock.de>
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ZOOM_SHADOWVOLUME_H_
#define ZOOM_SHADOWVOLUME_H_

#include <vmmlib/vector.hpp>
#include <vmmlib/matrix.hpp>

namespace Zoom {

class Triangle;

class ShadowVolume {
  public:
    ShadowVolume(const Triangle &t, const vmml::vec3f &lightPos);
    virtual ~ShadowVolume() {}

    const vmml::vec3f& getVertex(int i) {
      return rays[i].p;
    }

    const vmml::vec3f& getDirection(int i) {
      return rays[i].dir;
    }

    void render() const;

  private:
    bool visible;

    struct Ray {
        vmml::vec3f p;
        vmml::vec3f dir;
    } rays[3];
};

}

#endif /* ZOOM_SHADOWVOLUME_H_ */
